#!/usr/bin/perl -w

require '/var/smoothwall/header.pl';

my %pppsettings;

print "Content-type: text/html\n\n";

$pppsettings{'PERSISTANT'} = 'off';
$pppsettings{'ACTION'} = '';
&getcgihash(\%pppsettings);

# Sanitise
if ($pppsettings{'DNS1'} ne '')
{
	if ($pppsettings{'DNS1'} =~ /(\d+\.\d+\.\d+\.\d+)/) {
		$pppsettings{'DNS1'} = $1; }
	else {
		$pppsettings{'DNS1'} = 'ERROR'; }
}
if ($pppsettings{'DNS2'} ne '')
{
 	if ($pppsettings{'DNS2'} =~ /(\d+\.\d+\.\d+\.\d+)/) {
		$pppsettings{'DNS2'} = $1; }
	else {
              	$pppsettings{'DNS2'} = 'ERROR'; }
}

if ($pppsettings{'LOGINSCRIPT'} =~ /(\w+)/) {
	$pppsettings{'LOGINSCRIPT'} = $1; }
else {
	$pppsettings{'LOGINSCRIPT'} = ''; }

if ($pppsettings{'MAXRETRIES'} =~ /(\d+)/) {
	$pppsettings{'MAXRETRIES'} = $1; }
else {
	$pppsettings{'MAXRETRIES'} = 1; }


if ($pppsettings{'ACTION'} eq 'Save')
{
	# write cgi vars to the file.
	&writehash("${swroot}/ppp/settings", \%pppsettings);

	# write secrets file.
	open(FILE, ">/${swroot}/ppp/secrets") or die "Unable to write secrets file";
	$username = $pppsettings{'USERNAME'};
	$password = $pppsettings{'PASSWORD'};
	print FILE "$username * $password\n";
	close FILE;
}

# read vars back from file.
&readhash("${swroot}/ppp/settings", \%pppsettings);

$selected{'COMPORT'}{'ttyS0'} = '';
$selected{'COMPORT'}{'ttyS1'} = '';
$selected{'COMPORT'}{$pppsettings{'COMPORT'}} = 'SELECTED';

$selected{'AUTH'}{'pap'} = '';
$selected{'AUTH'}{'chap'} = '';
$selected{'AUTH'}{'standard-login-script'} = '';
$selected{'AUTH'}{'demon-login-script'} = '';
$selected{'AUTH'}{'other-login-script'} = '';
$selected{'AUTH'}{$pppsettings{'AUTH'}} = 'SELECTED';

$checked{'DNS'}{'Automatic'} = '';
$checked{'DNS'}{'Manual'} = '';
$checked{'DNS'}{$pppsettings{'DNS'}} = 'CHECKED';

$checked{'PERSISTANT'}{'off'} = '';
$checked{'PERSISTNAT'}{'on'} = '';
$checked{'PERSISTANT'}{$pppsettings{'PERSISTANT'}} = 'CHECKED';

&openpage("SmoothWall - PPP setup");

&openbigbox('100%', 'LEFT');

print "<FORM METHOD='POST'>\n";

&openbox('100%', 'LEFT', 'Telephony:');
print <<END
<TABLE WIDTH='100%'>
<TR><TD>Interface: </TD><TD>
<SELECT NAME='COMPORT'>
<OPTION VALUE='ttyS0' $selected{'COMPORT'}{'ttyS0'}>Modem on COM1
<OPTION VALUE='ttyS1' $selected{'COMPORT'}{'ttyS1'}>Modem on COM2
</SELECT>
</TD><TD>Number: </TD><TD>
<INPUT TYPE='text' NAME='TELEPHONE' VALUE='$pppsettings{'TELEPHONE'}'>
</TD></TR></TABLE>
END
;
&closebox();

&openbox('100%', 'LEFT', 'Authentication:');
print <<END
<TABLE WIDTH='100%'>
<TR><TD>Username: </TD><TD>
<INPUT TYPE='text' NAME='USERNAME' VALUE='$pppsettings{'USERNAME'}'>
</TD><TD>Password: </TD><TD>
<INPUT TYPE='password' NAME='PASSWORD' VALUE='$pppsettings{'PASSWORD'}'>
</TD></TR>
<TR><TD>Method: </TD><TD>
<SELECT NAME='AUTH'>
<OPTION $selected{'AUTH'}{'pap'} VALUE='pap'>pap
<OPTION $selected{'AUTH'}{'chap'} VALUE='chap'>chap
<OPTION $selected{'AUTH'}{'standard-login-script'} VALUE='standard-login-script'>standard-login-script
<OPTION $selected{'AUTH'}{'demon-login-script'} VALUE='demon-login-script'>demon-login-script
<OPTION $selected{'AUTH'}{'other-login-script'} VALUE='other-login-script'>other-login-script
</SELECT>
</TD><TD>Script name: </TD><TD>
<INPUT TYPE='text' NAME='LOGINSCRIPT' VALUE='$pppsettings{'LOGINSCRIPT'}'>
</TD></TR></TABLE>
END
;
&closebox();

&openbox('100%', 'LEFT', 'DNS:');
print <<END
<TABLE WIDTH='100%'>
<TR><TD>Type: </TD><TD COLSPAN=3>
<INPUT TYPE='radio' NAME='DNS' VALUE='Manual' $checked{'DNS'}{'Manual'}>Manual
<INPUT TYPE='radio' NAME='DNS' VALUE='Automatic' $checked{'DNS'}{'Automatic'}>Automatic
</TD></TR>
<TR><TD>Primary DNS: </TD><TD>
<INPUT TYPE='text' NAME='DNS1' VALUE='$pppsettings{'DNS1'}'>
</TD><TD>Secondary DNS: </TD><TD>
<INPUT TYPE='text' NAME='DNS2' VALUE='$pppsettings{'DNS2'}'>
</TD></TR></TABLE>
END
;
&closebox();

&openbox('100%', 'CENTER', 'Advanced:');
print <<END
<TABLE WIDTH='100%'>
<TR><TD>Maximum retries: </TD><TD>
<INPUT TYPE='text' NAME='MAXRETRIES' VALUE='$pppsettings{'MAXRETRIES'}'>
</TD><TD>
<INPUT TYPE='checkbox' NAME='PERSISTANT' VALUE='on' $checked{'PERSISTANT'}{'on'}>Persistant connection
</TD></TR></TABLE>
END
;
&closebox();

print <<END
<DIV ALIGN='CENTER'>
<TABLE WIDTH='60%'>
<TR><TD>
<INPUT type='submit' NAME='ACTION' VALUE='Save'>
</TD><TD>
<INPUT type='submit' NAME='ACTION' VALUE='Restore'>
</TD><TD>
<A HREF='/cgi-bin/index.cgi'>BACK</A>
</TD></TR></TABLE>
</DIV>
END
;

print "</FORM>";

&closebigbox();

&closepage();
